//Sequence BAC or CBA or ACB 
bool active = false;
unsigned int Delay = 1000;
unsigned int min_delay = 10000;
unsigned int max_delay = 3000;
int duty = 110;
int cycle = 420;
unsigned int actual_time, prev_time, prev_time_2, prev_time_3;
int phase = 0;
bool state = true;

void setup() {
  DDRB |=  B00001110;         //PB1, PB2 and PB3 as OUTPUT
  PORTB &= ~B00001110;        //PB1, PB2 and PB3 to LOW  
  DDRB &= ~B00010000;         //PB4 as input (A2)

  actual_time = micros();
  prev_time = actual_time;
  prev_time_2 = actual_time;
  prev_time_3 = actual_time;
}

void loop() {
  int val = analogRead(A2);
  if(val > 100){                                          //Potentiometer threshold
    active = true;
    Delay = map(val, 100, 1024, min_delay, max_delay);    //Map the speed delay
  }
  else if (val < 100){                                    //If below threshold, we turn off all pins. 
    active = false;
    PORTB &= ~B00001110;    //PB1, PB2 and PB3 to LOW
  }

  if(active){                                             //If active, we make the rotation loop
    actual_time = micros();    
    if(actual_time - prev_time >= Delay){                 //This if creates the delay between each phase
      prev_time += Delay;       
      phase++;                                            //Increase the phase to the next
      if(phase > 2){                                      //If phase = 3, we go back to 1 (0 to 2)
        phase = 0;
      }
    }//end of delay 
    
    if(actual_time - prev_time_2 >= cycle){               //This small "if" chops the phase in small pulses
      prev_time_2 = prev_time_2 + cycle;
      if(phase == 0){
        PORTB &= ~B00001100;
        PORTB |=  B00000010;
      }
      
      else if(phase == 1){
        PORTB &= ~B00001010;
        PORTB |=  B00000100;
      }
      
      else if(phase == 2){
        PORTB &= ~B00000110;
        PORTB |=  B00001000;
      }
      delayMicroseconds(duty);
      PORTB &= ~B00001110;
    }
  }//end of active 
}
